VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form MainForm 
   Caption         =   "Demo Quote Table"
   ClientHeight    =   5685
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   10620
   LinkTopic       =   "Form1"
   ScaleHeight     =   5685
   ScaleWidth      =   10620
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdRemoveAll 
      Caption         =   "RemoveAll"
      Height          =   495
      Left            =   6240
      TabIndex        =   5
      Top             =   240
      Width           =   1215
   End
   Begin VB.CommandButton cmdRemove 
      Caption         =   "Remove"
      Height          =   495
      Left            =   4920
      TabIndex        =   4
      Top             =   240
      Width           =   1215
   End
   Begin VB.CommandButton cmdAdd 
      Caption         =   "Add"
      Height          =   495
      Left            =   3600
      TabIndex        =   3
      Top             =   240
      Width           =   1215
   End
   Begin VB.TextBox txtSymbolID 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   1320
      TabIndex        =   2
      Top             =   240
      Width           =   2175
   End
   Begin MSFlexGridLib.MSFlexGrid grid 
      Height          =   4575
      Left            =   120
      TabIndex        =   0
      Top             =   840
      Width           =   7815
      _ExtentX        =   13785
      _ExtentY        =   8070
      _Version        =   393216
   End
   Begin VB.Label Label1 
      Caption         =   "SymbolID:"
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   360
      Width           =   975
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private WithEvents m_objApp As JDHNSQuoteOBJLib.ApplicationJDHNSQuote
Attribute m_objApp.VB_VarHelpID = -1

'
Const COL_ID = 1
Const COL_TIME = 2
Const COL_PRICE = 3
Const COL_VOLUME = 4
Const COL_TOTALVOLUME = 5
Const COL_BID = 6
Const COL_ASK = 7
Const COL_BIDSIZE = 8
Const COL_ASKSIZE = 9
Const COL_PRECLOSE = 10
Const COL_MAX = 11

' Index within Quote
'
Const FIELD_TIME = 33
Const FIELD_PRICE = 34
Const FIELD_VOLUME = 38
Const FIELD_TOTALVOLUME = 39
Const FIELD_BID = 8
Const FIELD_BIDSIZE = 13
Const FIELD_ASK = 18
Const FIELD_ASKSIZE = 23
Const FIELD_PRECLOSE = 1
Const FIELD_TICKINDEX = 32
Const FIELD_DP = 53


Private Sub cmdAdd_Click()
    On Error Resume Next
    
    If txtSymbolID.Text = "" Then
        MsgBox "Please enter a valid symbol ID"
        Exit Sub
    End If
    
    If InStr(txtSymbolID.Text, ".") < 0 Then
        MsgBox "Please enter a valid symbol ID"
        Exit Sub
    End If
    
    ' Check if this symbol is already added
    '
    Dim strSymbolID
    strSymbolID = UCase(txtSymbolID.Text)
    
    If IsSymbolExist(strSymbolID) Then
        MsgBox "Symbol already exists"
        Exit Sub
    End If

    ' Add Symbol
    '
    Call AddSymbol(strSymbolID)
    
End Sub

Private Sub cmdRemove_Click()
    On Error Resume Next
    
    If txtSymbolID.Text = "" Then
        MsgBox "Please enter a valid symbol ID"
        Exit Sub
    End If
    
    If InStr(txtSymbolID.Text, ".") < 0 Then
        MsgBox "Please enter a valid symbol ID"
        Exit Sub
    End If
    
    ' Check if this symbol is already added
    '
    Dim strSymbolID
    strSymbolID = UCase(txtSymbolID.Text)
    
    If Not IsSymbolExist(strSymbolID) Then
        MsgBox "Symbol does not exist"
        Exit Sub
    End If

    Call RemoveSymbol(strSymbolID)
    
End Sub

Private Sub cmdRemoveAll_Click()
    On Error Resume Next
    Call RemoveAllSymbols(True)
End Sub

Private Sub Form_Load()
    On Error GoTo ErrOut
    ' Initialize object
    '
    Set m_objApp = New JDHNSQuoteOBJLib.ApplicationJDHNSQuote
    Call m_objApp.Init
    
    ' Initialize Grid
    '
    Call InitGrid
    
    ' Position Grid
    '
    Call PositionGrid
    
    ' Initialize Grid content with some predefined symbols
    '
    Call InitSampleSymbols
    
    Exit Sub
ErrOut:
    MsgBox Err.Description
End Sub

Private Sub Form_Resize()
    ' Position Grid
    '
    Call PositionGrid
End Sub

Private Sub Form_Unload(Cancel As Integer)
    ' Need to remove all referenced symbols
    '
    Call RemoveAllSymbols(False)
End Sub

Private Sub grid_Click()
    ' Update selected symbols
    '
    If grid.Row > 1 Then
        txtSymbolID.Text = grid.TextMatrix(grid.Row, COL_ID)
    End If
End Sub

Private Sub m_objApp_OnSymbolRefresh(ByVal SymbolID As String, ByVal val As Variant)
    ' Ƨs
    '
    On Error Resume Next
    Call UpdateQuote(SymbolID)
End Sub

Private Sub m_objApp_OnSymbolSunrise(ByVal SymbolID As String, ByVal val As Variant)
    ' ML
    '
    On Error Resume Next
    Call UpdateQuote(SymbolID)
End Sub

Private Sub m_objApp_OnSymbolTick(ByVal SymbolID As String, ByVal val As Variant)
    ' 
    '
    On Error Resume Next
    Call UpdateQuote(SymbolID)
End Sub

Sub InitGrid()
    grid.Rows = 1
    grid.Cols = COL_MAX
    grid.ColAlignment(-1) = 4
    grid.TextMatrix(0, COL_ID) = "NX"
    grid.TextMatrix(0, COL_TIME) = "ɶ"
    grid.TextMatrix(0, COL_PRICE) = ""
    grid.TextMatrix(0, COL_VOLUME) = "q"
    grid.TextMatrix(0, COL_TOTALVOLUME) = "`q"
    grid.TextMatrix(0, COL_BID) = "Ri"
    grid.TextMatrix(0, COL_ASK) = "X"
    grid.TextMatrix(0, COL_BIDSIZE) = "eR"
    grid.TextMatrix(0, COL_ASKSIZE) = "e"
    grid.TextMatrix(0, COL_PRECLOSE) = "Q"
End Sub

Sub PositionGrid()
    grid.Left = 4
    grid.Width = Me.Width - 80
    grid.Top = 1000
    grid.Height = Me.Height - 1000 - 40
End Sub

Sub InitSampleSymbols()
    Call AddSymbol("TSE.TW")
    Call AddSymbol("1101.TW")
    Call AddSymbol("1201.TW")
    Call AddSymbol("1301.TW")
    Call AddSymbol("2317.TW")
    Call AddSymbol("2330.TW")
    Call AddSymbol("2409.TW")
End Sub

' Check if strSymbolID is in the grid
'
Private Function IsSymbolExist(ByVal strSymbolID As String) As Boolean
    If FindSymbol(strSymbolID) > 0 Then
        IsSymbolExist = True
    Else
        IsSymbolExist = False
    End If
End Function

' Locate the row index of strSymbolID in the grid
'
Private Function FindSymbol(ByVal strSymbolID As String) As Integer
    Dim i As Integer
    For i = 1 To grid.Rows - 1
        
        If strSymbolID = grid.TextMatrix(i, COL_ID) Then
            FindSymbol = i
            Exit Function
        End If
    Next
    FindSymbol = 0
End Function

' Add a symbol
'
Private Sub AddSymbol(ByVal strSymbolID As String)
    ' AddRef
    '
    Call m_objApp.AddSymbols(strSymbolID)
    
    ' Add to grid
    '
    grid.AddItem ("")
    grid.TextMatrix(grid.Rows - 1, COL_ID) = strSymbolID
    
    ' Update current value
    '
    Call UpdateQuote(strSymbolID)
End Sub

' Remove a symbol
'
Private Sub RemoveSymbol(ByVal strSymbolID As String)
    ' RemoveRef
    '
    Call m_objApp.RemoveSymbols(strSymbolID)

    ' remove from grid
    '
    Dim idx As Integer
    idx = FindSymbol(strSymbolID)
    If idx > 0 Then
        Call grid.RemoveItem(idx)
    End If
End Sub

Private Sub RemoveAllSymbols(ByVal RemoveGrid As Boolean)
    'Dim idx As Integer
    'Dim strSymbolID As String
    'For idx = 1 To grid.Rows - 1
     '   strSymbolID = grid.TextMatrix(idx, COL_ID)
      '  Call m_objApp.RemoveSymbols(strSymbolID)
    'Next
    
    Call m_objApp.RemoveAllSymbols

    If RemoveGrid Then
        grid.Rows = 1   '' remove all other rows except header
    End If
End Sub

' Core function to update quote data
'
Private Sub UpdateQuote(ByVal strSymbolID As String)
    Dim idx As Integer
    idx = FindSymbol(strSymbolID)
    If idx = 0 Then Exit Sub
    
    ' Grab data from JD
    '
    Dim quote() As Variant
    quote = m_objApp.GetQuote(strSymbolID)

    ' Display to grid
    '
    Dim lTickIndex As Long
    Dim Price As Single
    Dim Volume As Long
    Dim TotalVolume As Long
    Dim Time As Long
    Dim DP As Long
    
    ' oثeTick Index: pGO0, ܨS
    '
    lTickIndex = quote(FIELD_TICKINDEX)
    If lTickIndex = 0 Then
        Time = 0
        Price = 0
        Volume = 0
        TotalVolume = 0
    Else
        Time = quote(FIELD_TIME)
        Price = quote(FIELD_PRICE)
        Volume = quote(FIELD_VOLUME)
        TotalVolume = quote(FIELD_TOTALVOLUME)
    End If
    
    DP = quote(FIELD_DP)
    
    With grid
        .TextMatrix(idx, COL_TIME) = FormatTime(Time)
        .TextMatrix(idx, COL_PRICE) = ToRealPrice(Price, DP)
        .TextMatrix(idx, COL_VOLUME) = Volume
        .TextMatrix(idx, COL_TOTALVOLUME) = TotalVolume
        .TextMatrix(idx, COL_BID) = ToRealPrice(quote(FIELD_BID), DP)
        .TextMatrix(idx, COL_ASK) = ToRealPrice(quote(FIELD_ASK), DP)
        .TextMatrix(idx, COL_BIDSIZE) = quote(FIELD_BIDSIZE)
        .TextMatrix(idx, COL_ASKSIZE) = quote(FIELD_ASKSIZE)
        .TextMatrix(idx, COL_PRECLOSE) = ToRealPrice(quote(FIELD_PRECLOSE), DP)
    End With
    
End Sub
